#ifndef  __DVP_OV7740_H__
#define  __DVP_OV7740_H__

#include <stdio.h>
#include <string.h>
#include "dvp.h"
#include "fpioa.h"
#include "lcd.h"
#include "ov2640.h"
#include "plic.h"
#include "sysctl.h"
#include "uarths.h"
#include "nt35310.h"
#include "board_config.h"
#include "unistd.h"
#include "gpiohs.h"
#include "uart.h"
#include "stdlib.h"
#include "sdcard.h"
#include "ff.h"
#include "bsp.h"
#include "dvp.h"
#include "i2c.h"
#define OV7740_SET_MIRROR(r, x)   ((r&0xBF)|((x&1)<<6))
#define OV7740_SET_FLIP(r, x)     ((r&0x7F)|((x&1)<<7))
#define OV7740_ADDR         (0x42)

int ov7740_init(void);
void ov7740_wr_reg(uint8_t num, uint8_t reg,uint8_t data);
uint8_t ov7740_rd_reg(uint8_t num, uint8_t reg);

typedef struct 
{
    char gs_bpp;
    void* reset;
    void* sleep;
    void* read_reg;
    void* write_reg;
    void* set_pixformat;
    void* set_framesize;
    void* set_framerate;
    void* set_contrast;
    void* set_brightness;
    void* set_saturation;
    void* set_gainceiling;
    void* set_colorbar;
    void* set_auto_gain;
    void* get_gain_db;
    void* set_auto_exposure;
    void* get_exposure_us;
    void* set_auto_whitebal;
    void* get_rgb_gain_db;
    void* set_hmirror;
    void* set_vflip;
    void* set_special_effect;
    void* set_lens_correction;
}sensor_t;

#endif

